Given the root
of a binary tree, split the binary tree into two subtrees by removing one edge such that the product of the sums of the subtrees is maximized.
Return the maximum product of the sums of the two subtrees. Since the answer may be too large, return it modulo 109 + 7
.
Note that you need to maximize the answer before taking the mod and not after taking it.
Example 1:
Input: root = [1,2,3,4,5,6] Output: 110 Explanation: Remove the red edge and get 2 binary trees with sum 11 and 10. Their product is 110 (11*10)
Example 2:
Input: root = [1,null,2,3,4,null,null,5,6] Output: 90 Explanation: Remove the red edge and get 2 binary trees with sum 15 and 6.Their product is 90 (15*6)
Example 3:
Input: root = [2,3,9,10,7,8,6,5,4,11,1] Output: 1025
Example 4:
Input: root = [1,1] Output: 1
Constraints:
- The number of nodes in the tree is in the range
[2, 5 * 104]
. 1 <= Node.val <= 104
Companies:
ByteDance, Amazon, Microsoft
Related Topics:
Tree, Depth-First Search, Binary Tree
// OJ: https://leetcode.com/problems/maximum-product-of-splitted-binary-tree/
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(H)
class Solution {
long total = 0, ans = 0, mod = 1e9 + 7;
void sum(TreeNode *root) {
if (!root) return;
total += root->val;
sum(root->left);
sum(root->right);
}
long dfs(TreeNode *root) {
if (!root) return 0;
long s = root->val + dfs(root->left) + dfs(root->right);
ans = max(ans, (total - s) * s);
return s;
}
public:
int maxProduct(TreeNode* root) {
sum(root);
dfs(root);
return ans % mod;
}
};
Or
// OJ: https://leetcode.com/problems/maximum-product-of-splitted-binary-tree/
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(H)
class Solution {
long total = 0, mod = 1e9 + 7, ans = 0;
long postorder(TreeNode *root) {
if (!root) return 0;
int sum = root->val + postorder(root->left) + postorder(root->right);
if (total) ans = max(ans, sum * (total - sum));
return sum;
}
public:
int maxProduct(TreeNode* root) {
total = postorder(root);
postorder(root);
return ans % mod;
}
};